SystemOrganization addCategory: #PhileasFogg!

Object subclass: #PhileasFogg
	instanceVariableNames: 'topicClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:42'!
classesReferencingTopicClass
	^ (topicClass theNonMetaClass asNode users collect: [ :each | each theClass theNonMetaClass ]) asSet
		copyWithout: topicClass! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:01'!
goSuperclass

	self topicClass superclass isNil ifFalse: [self topicClass: self topicClass superclass ]! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:32'!
instanceVariableNamesOfTopicClass
	^ topicClass instVarNames! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:28'!
nameOfSuperclassOfTopicClass
	^ topicClass superclass name! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:28'!
nameOfTopicClass
	^ topicClass name! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:52'!
topicClass

	^ topicClass! !

!PhileasFogg methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:17'!
topicClass: aClass 

	topicClass := aClass.
	self changed: #topicClass.
! !

Object subclass: #PhileasFoggController
	instanceVariableNames: 'window model contentView classNameTextMorph superclassButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:29'!
classNameTextMorph

	^classNameTextMorph ifNil: [
		classNameTextMorph := model nameOfTopicClass asMorph.
		classNameTextMorph font:  (StrikeFont familyName: #Accuny size: 30).
		classNameTextMorph top: self superclassButton bottom + 5. 
		]! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 16:42'!
contentView

	^contentView isNil ifTrue: [
		contentView := Morph new. contentView extent: 300@300.
		contentView addMorph: self superclassButton.
		contentView addMorph: self classNameTextMorph  ]! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:17'!
goSuperclass

	model goSuperclass! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:12'!
initialize

	super initialize.
	self model: PhileasFogg new.! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:18'!
model: aPhileasFogg 
  
	model ifNotNil: [ model breakDependents ].
	model := aPhileasFogg.
	model addDependent: self.! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:25'!
nameOfSuperclass

	^model nameOfSuperclassOfTopicClass ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 16:46'!
shouldEnableSuperclassButton

	^true! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:17'!
superclassButton

	^superclassButton ifNil: [superclassButton := PluggableButtonMorph on: self getState: nil action: #goSuperclass label: #nameOfSuperclass  ].! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:02'!
topicClass: aClass 

	model topicClass: aClass  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 17:28'!
update: aSymbol

	aSymbol = #topicClass ifTrue: [ 
		self changed: #nameOfSuperclass.
		classNameTextMorph contents: model nameOfTopicClass. 
		^self ].
	Transcript show: aSymbol;cr;flush.  ! !

!PhileasFoggController methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:46'!
window

	window ifNil: [window := self contentView openInWindow]  ! !

Object subclass: #PhileasFoggTranscriptor
	instanceVariableNames: 'topicClass model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PhileasFogg'!

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:51'!
initialize

	super initialize.
	model := PhileasFogg new.! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:57'!
main
	Transcript clear.
	self transcriptLine: '- class name -'.
	self transcriptLine: model nameOfTopicClass.
	self transcriptLine: '- superclass name -'.
	self transcriptLine: model nameOfSuperclassOfTopicClass.
	self transcriptLine: '- instance variable names -'.
	model instanceVariableNamesOfTopicClass do: [ :each | self transcriptLine: each ].
	self transcriptLine: '- referencing classes -'.
	model classesReferencingTopicClass do: [ :each | self transcriptLine: each printString ].
	self transcriptLine: '- end -'.
	Transcript flush! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 12:15'!
model: aPhileasFogg 

	model := aPhileasFogg! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:50'!
topicClass: aClass 

	model topicClass: aClass! !

!PhileasFoggTranscriptor methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2011 11:47'!
transcriptLine: aString
	^ Transcript
		nextPutAll: aString;
		cr! !
